import random


def generate_memorable_available_string(taken_strings):
    name = None
    while (not name) or name in taken_strings:
        name = generate_memorable_string()
    return name


def generate_memorable_string(num_words=2, separator="_"):
    """
    Generate a random name by combining words from predefined lists.

    Args:
        num_words (int): Number of words to combine (default: 2)
        separator (str): String to join words with (default: '_')

    Returns:
        str: Combined random words
    """

    adjectives = [
        "happy",
        "clever",
        "swift",
        "brave",
        "bright",
        "calm",
        "eager",
        "fierce",
        "gentle",
        "kind",
        "lively",
        "proud",
        "quiet",
        "rapid",
        "sharp",
        "smart",
        "strong",
        "warm",
        "wise",
        "bold",
        "crisp",
        "deep",
        "free",
        "grand",
        "high",
        "keen",
        "neat",
        "rich",
        "safe",
        "true",
        "young",
        "dark",
        "light",
        "wild",
        "soft",
        "loud",
        "quick",
        "slow",
        "tall",
        "short",
        "fresh",
        "clean",
        "cool",
        "hot",
        "fair",
        "sweet",
        "tough",
        "pure",
        "nice",
        "raw",
        "real",
        "rare",
        "fine",
        "vast",
        "mild",
        "firm",
        "fast",
        "late",
        "main",
        "wide",
        "deep",
        "blue",
        "red",
        "green",
        "gold",
        "pink",
        "gray",
        "tiny",
        "huge",
        "broad",
        "flat",
        "thick",
        "thin",
        "white",
        "black",
        "round",
        "dry",
        "wet",
        "full",
        "empty",
        "heavy",
        "light",
        "loose",
        "tight",
        "long",
        "brief",
        "clear",
        "dark",
        "busy",
        "lazy",
        "spare",
        "prime",
        "royal",
        "plain",
        "spare",
        "crude",
        "chief",
        "swift",
        "dim",
        "dull",
        "rough",
        "smooth",
        "still",
        "small",
        "great",
        "quick",
        "ready",
        "right",
        "rust",
        "tame",
        "vital",
        "young",
        "zinc",
        "zesty",
    ]

    nouns = [
        "apple",
        "bear",
        "bird",
        "cat",
        "cloud",
        "deer",
        "dog",
        "fish",
        "fox",
        "frog",
        "hawk",
        "lion",
        "moon",
        "owl",
        "pine",
        "rose",
        "star",
        "sun",
        "tree",
        "wolf",
        "river",
        "mountain",
        "ocean",
        "forest",
        "desert",
        "valley",
        "meadow",
        "garden",
        "brook",
        "lake",
        "beach",
        "cliff",
        "coast",
        "creek",
        "field",
        "flame",
        "flood",
        "frost",
        "glade",
        "grove",
        "shore",
        "spring",
        "storm",
        "stream",
        "tide",
        "trail",
        "whale",
        "wind",
        "wood",
        "world",
        "amber",
        "ash",
        "balm",
        "bark",
        "bay",
        "blade",
        "bloom",
        "branch",
        "brass",
        "bronze",
        "cane",
        "cedar",
        "chalk",
        "clay",
        "cliff",
        "coal",
        "coast",
        "coral",
        "crown",
        "crystal",
        "dew",
        "dove",
        "drake",
        "dune",
        "dust",
        "elm",
        "fern",
        "flake",
        "flame",
        "flock",
        "foam",
        "fog",
        "frost",
        "gale",
        "gem",
        "gill",
        "glacier",
        "grove",
        "gull",
        "harbor",
        "hare",
        "heath",
        "hill",
        "jazz",
        "jewel",
        "kale",
        "kelp",
        "kite",
        "lark",
        "leaf",
        "lime",
        "mane",
        "marsh",
        "mint",
        "mist",
        "moss",
        "nest",
        "night",
        "north",
        "oak",
        "opal",
        "otter",
        "palm",
        "peak",
        "pear",
        "pearl",
        "petal",
        "pike",
        "pine",
        "plant",
        "plum",
        "pond",
        "pool",
        "quail",
        "queen",
        "quill",
        "rain",
        "reef",
        "rice",
        "ridge",
        "rock",
        "root",
        "rose",
        "ruby",
        "rush",
        "sage",
        "sail",
        "salt",
        "sand",
        "seal",
        "seed",
        "shark",
        "shell",
        "shore",
        "silk",
        "slag",
        "slate",
        "sleet",
        "slope",
        "snow",
        "south",
        "spark",
        "spine",
        "spray",
        "spring",
        "sprout",
        "squid",
        "star",
        "stone",
        "storm",
        "swan",
        "swift",
        "tank",
        "tide",
        "tiger",
        "torch",
        "trout",
        "tulip",
        "vapor",
        "vine",
        "voice",
        "wave",
        "weed",
        "well",
        "whale",
        "wind",
        "wing",
        "winter",
        "wolf",
        "womb",
        "wood",
        "wren",
        "yarn",
        "yeast",
        "zebra",
    ]

    verbs = [
        "running",
        "jumping",
        "flying",
        "dancing",
        "singing",
        "laughing",
        "sleeping",
        "dreaming",
        "playing",
        "swimming",
        "climbing",
        "diving",
        "gliding",
        "hopping",
        "leaping",
        "racing",
        "skating",
        "sliding",
        "walking",
        "wandering",
        "acting",
        "baking",
        "being",
        "brewing",
        "buying",
        "calling",
        "caring",
        "catching",
        "chasing",
        "coding",
        "cooking",
        "dealing",
        "doing",
        "drawing",
        "driving",
        "eating",
        "falling",
        "feeling",
        "finding",
        "flowing",
        "giving",
        "glowing",
        "going",
        "growing",
        "having",
        "hearing",
        "hiding",
        "hitting",
        "holding",
        "keeping",
        "knowing",
        "leading",
        "leaving",
        "making",
        "moving",
        "painting",
        "playing",
        "reading",
        "riding",
        "rising",
        "saying",
        "seeing",
        "selling",
        "sending",
        "setting",
        "shining",
        "showing",
        "singing",
        "sitting",
        "speaking",
        "spending",
        "standing",
        "staying",
        "taking",
        "talking",
        "teaching",
        "telling",
        "thinking",
        "turning",
        "using",
        "waiting",
        "watching",
        "winning",
        "working",
        "writing",
        "zooming",
    ]

    # Create a list of all word lists to choose from
    word_lists = [adjectives, nouns, verbs]

    # Select random words from different categories
    selected_words = []
    while len(selected_words) < num_words:
        # Get a random word list
        word_list = random.choice(word_lists)
        # Get a random word from that list
        word = random.choice(word_list)
        # Only add if we haven't used this word yet
        if word not in selected_words:
            selected_words.append(word)

    return separator.join(selected_words)
